/***************************************************************************
                          OcPoints.h  -  description
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Ian Porter
    email                : ian@designersoft.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _OCPOINTS
#define _OCPOINTS

#include "frustum.h"

// new start
enum OctreeParts {
  TOP_FRONT_LEFT, TOP_FRONT_RIGHT, TOP_BACK_LEFT, TOP_BACK_RIGHT,
  BOTTOM_FRONT_LEFT, BOTTOM_FRONT_RIGHT, BOTTOM_BACK_LEFT, BOTTOM_BACK_RIGHT
};

#define rep_count 1
unsigned int repeat_count =0;

struct OctreePoints_2{
    float x[3],y[3],z[3];

    void copy(OctreePoints_2 OC) {
        for (int count = 0; count < 3; count++) {
              x[count] = OC.x[count];
              y[count] = OC.y[count];
              z[count]  = OC.z[count];
          }
    }
};

class Octree_2 {
    private:
      unsigned int number_of_traingles, vertics_count[8];
      float place[3], Oc_width;
      OctreePoints_2 *vertics[8];
      bool root;
      Octree_2 *children[8];
    public:
       Octree_2() {Init_Octree_2() ;}
       void Init_Octree_2();
       bool ret_root() { return root;}
       bool display(Frustum frustum);
       bool create_node(OctreePoints_2 *OC, unsigned int number, float width, float insert[3], bool inc);
       float *ret_place() { return place; }
       float ret_width() { return Oc_width; }
//       ~Octree_2() { delete vertics; delete children;}
};

float tester[8][3];
void create_box_centre(float width, float insert[3]);

void Octree_2::Init_Octree_2()
{
  // setup the default information for the object.
  number_of_traingles = 0;
  root = true;
  place[0] = place[1] = place[2] = 0.0f;        // center
  for (int i =0; i < 8; i++)                                // no vertics per cell
    vertics_count[i] = 0;
}

bool Octree_2::display(Frustum frustum)
{
  int box;
  if (root == false) {                            // if a root (holding the vertics data) then display the vertics data
    for ( box =0; box < 8; box++) {
//     printf("\n\n\nCell :%i\n\n\n", box);
      for (unsigned int i =0; i < vertics_count[box]; i++) {
//       printf("\n\n%i\n\n",i);

       for (int j =0; j < 3; j++)
             glVertex3f( vertics[box][i].x[j], vertics[box][i].y[j], vertics[box][i].z[j] );                                                      // coords of the object
//        printf("%f\t%f\t%f\n", vertics[box][i].x[j], vertics[box][i].y[j], vertics[box][i].z[j]);
      }
    }
  } else {                                            // else go into the children for the class
      for (box = 0; box < 8; box++) {
//          printf("\nBox Number : %i\n",box);
           if (frustum.CubeInFrustum(children[box]->ret_place(), children[box]->ret_width()  ) )
                children[box]->display(frustum);
      }
  }
  return true;
}


bool Octree_2::create_node(OctreePoints_2 *OC, unsigned int number, float width, float insert[3], bool inc = true)
{
    OctreePoints_2 ocbuild[8][number];
    unsigned int ocbuild_count[8], count, icount;

    number_of_traingles = number;
    for (count =0; count < 3; count++)      // setup the area for the cell of area e.g. 0,0,0 = center  -25,-25,-25 = top left
      place[count] = insert[count];

    for (count = 0; count < 8; count++)
      ocbuild_count[count] = 0;
      
     Oc_width = width;
     for (count = 0; count < number; count++) {
       for (icount = 0; icount < 3; icount++ ) {
          // box top front left
          if ( (OC[count].x[icount] <= insert[0]) && (OC[count].y[icount] <= insert[1]) && (OC[count].z[icount] <= insert[2]) )  {
               ocbuild[TOP_FRONT_LEFT][ocbuild_count[TOP_FRONT_LEFT]++].copy(OC[count]);
               break;
           }
          // box top front right
          if ( (OC[count].x[icount] >= insert[0]) && (OC[count].y[icount] <= insert[1]) && (OC[count].z[icount] <= insert[2]) )    {
               ocbuild[TOP_FRONT_RIGHT][ocbuild_count[TOP_FRONT_RIGHT]++].copy(OC[count]);
               break;
           }
          // box top back left
          if ( (OC[count].x[icount] <= insert[0]) && (OC[count].y[icount] <= insert[1]) && (OC[count].z[icount] >= insert[2]) )   {
               ocbuild[TOP_BACK_LEFT][ocbuild_count[TOP_BACK_LEFT]++].copy(OC[count]);
               break;
           }
          // box top back right
          if ( (OC[count].x[icount] >= insert[0]) && (OC[count].y[icount] <= insert[1]) && (OC[count].z[icount] >= insert[2]) )   {
                ocbuild[TOP_BACK_RIGHT][ocbuild_count[TOP_BACK_RIGHT]++].copy(OC[count]);
               break;
           }
          // box bottom front left
          if ( (OC[count].x[icount] <= insert[0]) && (OC[count].y[icount] >= insert[1]) && (OC[count].z[icount] <= insert[2]) )   {
               ocbuild[BOTTOM_FRONT_LEFT][ocbuild_count[BOTTOM_FRONT_LEFT]++].copy(OC[count]);
               break;
           }
          // box bottom front right
          if ( (OC[count].x[icount] >= insert[0]) && (OC[count].y[icount] >= insert[1]) && (OC[count].z[icount] <= insert[2]) )   {
               ocbuild[BOTTOM_FRONT_RIGHT][ocbuild_count[BOTTOM_FRONT_RIGHT]++].copy(OC[count]);
               break;
           }
          // box bottom back left
          if ( (OC[count].x[icount] <= insert[0]) && (OC[count].y[icount] >= insert[1]) && (OC[count].z[icount] >= insert[2]) )  {
               ocbuild[BOTTOM_BACK_LEFT][ocbuild_count[BOTTOM_BACK_LEFT]++].copy(OC[count]);
               break;
           }
          // box bottom back right
          if ( (OC[count].x[icount] >= insert[0]) && (OC[count].y[icount] >= insert[1]) && (OC[count].z[icount] >= insert[2]) ) {
               ocbuild[BOTTOM_BACK_RIGHT][ocbuild_count[BOTTOM_BACK_RIGHT]++].copy(OC[count]);
               break;
           }
       }
     }

    if (inc == false) repeat_count ++;
    if (repeat_count == rep_count) {      // either test to see if hit the number of octo cuts, or could place the trees into this vertics if below a number in that tree
          for (count = 0 ; count < 8; count ++)                             //   place the ocbuild counts + vertics into the vertics object for this class
                 vertics_count[count] = ocbuild_count[count];
          for (count = 0; count < 8; count ++)
            for (icount = 0; icount < vertics_count[count]; icount++)
               vertics[count] = ocbuild[count];
          root = false;
      }
    else  {
        create_box_centre(width, insert);
        for (count = 0; count < 8; count ++)
        {
          children[count] = new Octree_2;
          if (count == 0)                                 // increment the repeat counter
            children[count]->create_node(ocbuild[count], ocbuild_count[count], float(width / 2), tester[count], false);
          else
            children[count]->create_node(ocbuild[count], ocbuild_count[count], float(width / 2), tester[count]);
        }
     }
    return true;
}

void create_box_centre(float width, float insert[3])
{
    // top front left
    width = width / 2;
    // top front left
    tester[0][0] = insert[0] - width; tester[0][1] = insert[1] - width; tester[0][2] = insert[2] - width;
    // top front right
    tester[1][0] = insert[0] + width; tester[1][1] = insert[1] - width; tester[1][2] = insert[2] - width;
    // top back left
    tester[2][0] = insert[0] - width; tester[2][1] = insert[1] - width; tester[2][2] = insert[2] + width;
    // top back right
    tester[3][0] = insert[0] + width; tester[3][1] = insert[1] - width; tester[3][2] = insert[2] + width;
    // bottom front left
    tester[4][0] = insert[0] - width; tester[4][1] = insert[1] + width; tester[4][2] = insert[2] - width;
    // bottom front right
    tester[5][0] = insert[0] + width; tester[5][1] = insert[1] + width; tester[5][2] = insert[2] - width;
    // bottom back left
    tester[6][0] = insert[0] - width; tester[6][1] = insert[1] + width; tester[6][2] = insert[2] + width;
    // bottom back right
    tester[7][0] = insert[0] + width; tester[7][1] = insert[1] + width; tester[7][2] = insert[2] + width;
}

#endif
