/*:
    camera.cpp : Learned from www.Gametutorials.com  (once got to a stage to re-program I shall )
    email ian@designersoft.co.uk
*/
#include "camera.h"

void Camera::Poistion_Camera() {
   gluLookAt(cam_point_eye.x, cam_point_eye.y, cam_point_eye.z,
   		cam_point_center.x, cam_point_center.y, cam_point_center.z,
		cam_point_up.x, cam_point_up.y, cam_point_up.z);
}

void Camera::Set_View_By_Mouse()
{
    int mouseX,mouseY;
    int middleX = SCREEN_WIDTH  >> 1;              // divide by 2
    int middleY = SCREEN_HEIGHT >> 1;
    float angleY = 0.0f;                           // looking up or down
    float angleZ = 0.0f;                           // rotate around the Y axis (Left and Right)
    static float currentRotX = 0.0f;

    SDL_GetMouseState(&mouseX,&mouseY);

    // If our cursor is still in the middle, we never moved... so don't update the screen
    if( (mouseX == middleX) && (mouseY == middleY) ) return;

    // Set the mouse position to the middle of our window
    SDL_WarpMouse(middleX, middleY);

    // Get the direction the mouse moved in, but bring the number down to a reasonable amount
    angleY = (float)( (middleX - mouseX) ) / mouse_movement;
    angleZ = (float)( (middleY - mouseY) ) / mouse_movement;

    // Here we keep track of the current rotation (for up and down) so that
    // we can restrict the camera from doing a full 360 loop.
    currentRotX -= angleZ;

    // If the current rotation (in radians) is greater than 1.0, we want to cap it.
    if(currentRotX > 1.0f)
        currentRotX = 1.0f;
    // Check if the rotation is below -1.0, if so we want to make sure it doesn't continue
    else if(currentRotX < -1.0f)
        currentRotX = -1.0f;
    else
    {
        // To find the axis we need to rotate around for up and down
        // movements, we need to get a perpendicular vector from the
        // camera's view vector and up vector.  This will be the axis.
        // Before using the axis, it's a good idea to normalize it first.
	CameraPoints Axis = cam_point_center - cam_point_eye;
	Axis = Axis.Cross(cam_point_up);
        Axis = Axis.Normalize(Axis);		// reduce the jumping from one position to the next.

        // Rotate around our perpendicular axis and along the y-axis
        Rotate_View(angleZ, Axis.x, Axis.y, Axis.z);
	Rotate_View(angleY, 0, 1, 0);	// left and right movement
    }
}

void Camera::Rotate_View(float angle, float x, float y, float z)
{
    CameraPoints NewView;

    // Get the view vector (The direction we are facing)
    CameraPoints View = cam_point_center - cam_point_eye;

    // Calculate the sine and cosine of the angle once
    float cosTheta = (float)cos(angle);
    float sinTheta = (float)sin(angle);

    // Find the new x position for the new rotated point
    NewView.x  = (cosTheta + (1 - cosTheta) * x * x)        * View.x;
    NewView.x += ((1 - cosTheta) * x * y - z * sinTheta)    * View.y;
    NewView.x += ((1 - cosTheta) * x * z + y * sinTheta)    * View.z;

    // Find the new y position for the new rotated point
    NewView.y  = ((1 - cosTheta) * x * y + z * sinTheta)    * View.x;
    NewView.y += (cosTheta + (1 - cosTheta) * y * y)        * View.y;
    NewView.y += ((1 - cosTheta) * y * z - x * sinTheta)    * View.z;

    // Find the new z position for the new rotated point
    NewView.z  = ((1 - cosTheta) * x * z - y * sinTheta)    * View.x;
    NewView.z += ((1 - cosTheta) * y * z + x * sinTheta)    * View.y;
    NewView.z += (cosTheta + (1 - cosTheta) * z * z)        * View.z;

    // Now we just add the newly rotated vector to our position to set
    // our new rotated view of our camera.
    cam_point_center = cam_point_eye + NewView;
}

void Camera::Move_Camera(float speed)
{
    // Get our view vector (The direciton we are facing)
    CameraPoints vVector = cam_point_center - cam_point_eye;

    cam_point_eye.x += vVector.x * speed;
    cam_point_eye.y +=vVector.y * speed;
    cam_point_eye.z += vVector.z * speed;
    cam_point_center.x += vVector.x * speed;
    cam_point_center.y += vVector.y * speed;
    cam_point_center.z += vVector.z * speed;
}



