/*
  Frustum.h : Frustum calculations
  email :   ian@designersoft.co.uk
*/

#ifndef _FRUST_INIT
#define _FRUST_INIT

#include "templates/def_include.h"

enum FR_SIDES {
  RIGHT = 0,
  LEFT = 1,
  BOTTOM = 2,
  TOP = 3,
  BACK = 4,
  FRONT = 5
};

enum FR_PLANES {
  A = 0,
  B = 1,
  C = 2,
  D = 3
};

class Frustum {
  private:
    float frustum[6][4];
  public:
    // normalize the plane 'x'
   void NormalizePlane(int side);

    // call every frame to setup the frustum
   void CalculateFrustum();

    // return true/flase if the point is in the view
   bool PointInFrustum(float x, float y, float z);

   // return a integer value hopefully to display the distance from another object.
   float PointInFrustumCal(float x,float y,float z, float size);

   // return true/false if the object is in the view
   bool SphereInFrustum(float x, float y, float z, float radius);

    // return true/false if the object is in the view   (size / 2)
   bool CubeInFrustum(float x, float y, float z, float size);
   bool CubeInFrustum(float xyz[3], float size);
   float CubeInFrustumCal(float x, float y, float z, float size);
};

#endif
